diff --git a/modules/NUCLEO-F401RE/board.h b/modules/NUCLEO-F401RE/board.h
index 353c10f..6210c80 100644
--- a/modules/NUCLEO-F401RE/board.h
+++ b/modules/NUCLEO-F401RE/board.h
@@ -71,8 +71,8 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 #define GPIOA_USART2_RX             3U
 #define GPIOA_ARD_A2                4U
 #define GPIOA_ADC1_IN4              4U
-#define GPIOA_LED_GREEN             5U
 #define GPIOA_ARD_D13               5U
+#define GPIOA_LED_GREEN             5U
 #define GPIOA_ARD_D12               6U
 #define GPIOA_ARD_D11               7U
 #define GPIOA_ARD_D7                8U
@@ -88,8 +88,8 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 #define GPIOB_ADC1_IN8              0U
 #define GPIOB_PIN1                  1U
 #define GPIOB_PIN2                  2U
-#define GPIOB_SWO                   3U
 #define GPIOB_ARD_D3                3U
+#define GPIOB_SWO                   3U
 #define GPIOB_ARD_D5                4U
 #define GPIOB_ARD_D4                5U
 #define GPIOB_ARD_D10               6U
@@ -227,47 +227,50 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 /*
  * IO lines assignments.
  */
-#define LINE_ARD_A0                 PAL_LINE(GPIOA, 0U)
-#define LINE_ADC1_IN0               PAL_LINE(GPIOA, 0U)
-#define LINE_ARD_A1                 PAL_LINE(GPIOA, 1U)
-#define LINE_ADC1_IN1               PAL_LINE(GPIOA, 1U)
-#define LINE_ARD_D1                 PAL_LINE(GPIOA, 2U)
-#define LINE_USART2_TX              PAL_LINE(GPIOA, 2U)
-#define LINE_ARD_D0                 PAL_LINE(GPIOA, 3U)
-#define LINE_USART2_RX              PAL_LINE(GPIOA, 3U)
-#define LINE_ARD_A2                 PAL_LINE(GPIOA, 4U)
-#define LINE_ADC1_IN4               PAL_LINE(GPIOA, 4U)
-#define LINE_LED_GREEN              PAL_LINE(GPIOA, 5U)
-#define LINE_ARD_D13                PAL_LINE(GPIOA, 5U)
-#define LINE_ARD_D12                PAL_LINE(GPIOA, 6U)
-#define LINE_ARD_D11                PAL_LINE(GPIOA, 7U)
-#define LINE_ARD_D7                 PAL_LINE(GPIOA, 8U)
-#define LINE_ARD_D8                 PAL_LINE(GPIOA, 9U)
-#define LINE_ARD_D2                 PAL_LINE(GPIOA, 10U)
-#define LINE_OTG_FS_DM              PAL_LINE(GPIOA, 11U)
-#define LINE_OTG_FS_DP              PAL_LINE(GPIOA, 12U)
-#define LINE_SWDIO                  PAL_LINE(GPIOA, 13U)
-#define LINE_SWCLK                  PAL_LINE(GPIOA, 14U)
-#define LINE_ARD_A3                 PAL_LINE(GPIOB, 0U)
-#define LINE_ADC1_IN8               PAL_LINE(GPIOB, 0U)
-#define LINE_SWO                    PAL_LINE(GPIOB, 3U)
-#define LINE_ARD_D3                 PAL_LINE(GPIOB, 3U)
-#define LINE_ARD_D5                 PAL_LINE(GPIOB, 4U)
-#define LINE_ARD_D4                 PAL_LINE(GPIOB, 5U)
-#define LINE_ARD_D10                PAL_LINE(GPIOB, 6U)
-#define LINE_ARD_D15                PAL_LINE(GPIOB, 8U)
-#define LINE_ARD_D14                PAL_LINE(GPIOB, 9U)
-#define LINE_ARD_D6                 PAL_LINE(GPIOB, 10U)
-#define LINE_ARD_A5                 PAL_LINE(GPIOC, 0U)
-#define LINE_ADC1_IN10              PAL_LINE(GPIOC, 0U)
-#define LINE_ARD_A4                 PAL_LINE(GPIOC, 1U)
-#define LINE_ADC1_IN11              PAL_LINE(GPIOC, 1U)
-#define LINE_ARD_D9                 PAL_LINE(GPIOC, 7U)
-#define LINE_BUTTON                 PAL_LINE(GPIOC, 13U)
-#define LINE_OSC32_IN               PAL_LINE(GPIOC, 14U)
-#define LINE_OSC32_OUT              PAL_LINE(GPIOC, 15U)
-#define LINE_OSC_IN                 PAL_LINE(GPIOH, 0U)
-#define LINE_OSC_OUT                PAL_LINE(GPIOH, 1U)
+#define LINE_ARD_A0                 PAL_LINE(GPIOA, GPIOA_ARD_A0)
+#define LINE_ADC1_IN0               PAL_LINE(GPIOA, GPIOA_ADC1_IN0)
+#define LINE_ARD_A1                 PAL_LINE(GPIOA, GPIOA_ARD_A1)
+#define LINE_ADC1_IN1               PAL_LINE(GPIOA, GPIOA_ADC1_IN1)
+#define LINE_ARD_D1                 PAL_LINE(GPIOA, GPIOA_ARD_D1)
+#define LINE_USART2_TX              PAL_LINE(GPIOA, GPIOA_USART2_TX)
+#define LINE_ARD_D0                 PAL_LINE(GPIOA, GPIOA_ARD_D0)
+#define LINE_USART2_RX              PAL_LINE(GPIOA, GPIOA_USART2_RX)
+#define LINE_ARD_A2                 PAL_LINE(GPIOA, GPIOA_ARD_A2)
+#define LINE_ADC1_IN4               PAL_LINE(GPIOA, GPIOA_ADC1_IN4)
+#define LINE_ARD_D13                PAL_LINE(GPIOA, GPIOA_ARD_D13)
+#define LINE_LED_GREEN              PAL_LINE(GPIOA, GPIOA_LED_GREEN)
+#define LINE_ARD_D12                PAL_LINE(GPIOA, GPIOA_ARD_D12)
+#define LINE_ARD_D11                PAL_LINE(GPIOA, GPIOA_ARD_D11)
+#define LINE_ARD_D7                 PAL_LINE(GPIOA, GPIOA_ARD_D7)
+#define LINE_ARD_D8                 PAL_LINE(GPIOA, GPIOA_ARD_D8)
+#define LINE_ARD_D2                 PAL_LINE(GPIOA, GPIOA_ARD_D2)
+#define LINE_OTG_FS_DM              PAL_LINE(GPIOA, GPIOA_OTG_FS_DM)
+#define LINE_OTG_FS_DP              PAL_LINE(GPIOA, GPIOA_OTG_FS_DP)
+#define LINE_SWDIO                  PAL_LINE(GPIOA, GPIOA_SWDIO)
+#define LINE_SWCLK                  PAL_LINE(GPIOA, GPIOA_SWCLK)
+
+#define LINE_ARD_A3                 PAL_LINE(GPIOB, GPIOB_ARD_A3)
+#define LINE_ADC1_IN8               PAL_LINE(GPIOB, GPIOB_ADC1_IN8)
+#define LINE_ARD_D3                 PAL_LINE(GPIOB, GPIOB_ARD_D3)
+#define LINE_SWO                    PAL_LINE(GPIOB, GPIOB_SWO)
+#define LINE_ARD_D5                 PAL_LINE(GPIOB, GPIOB_ARD_D5)
+#define LINE_ARD_D4                 PAL_LINE(GPIOB, GPIOB_ARD_D4)
+#define LINE_ARD_D10                PAL_LINE(GPIOB, GPIOB_ARD_D10)
+#define LINE_ARD_D15                PAL_LINE(GPIOB, GPIOB_ARD_D15)
+#define LINE_ARD_D14                PAL_LINE(GPIOB, GPIOB_ARD_D14)
+#define LINE_ARD_D6                 PAL_LINE(GPIOB, GPIOB_ARD_D6)
+
+#define LINE_ARD_A5                 PAL_LINE(GPIOC, GPIOC_ARD_A5)
+#define LINE_ADC1_IN10              PAL_LINE(GPIOC, GPIOC_ADC1_IN10)
+#define LINE_ARD_A4                 PAL_LINE(GPIOC, GPIOC_ARD_A4)
+#define LINE_ADC1_IN11              PAL_LINE(GPIOC, GPIOC_ADC1_IN11)
+#define LINE_ARD_D9                 PAL_LINE(GPIOC, GPIOC_ARD_D9)
+#define LINE_BUTTON                 PAL_LINE(GPIOC, GPIOC_BUTTON)
+#define LINE_OSC32_IN               PAL_LINE(GPIOC, GPIOC_OSC32_IN)
+#define LINE_OSC32_OUT              PAL_LINE(GPIOC, GPIOC_OSC32_OUT)
+
+#define LINE_OSC_IN                 PAL_LINE(GPIOH, GPIOH_OSC_IN)
+#define LINE_OSC_OUT                PAL_LINE(GPIOH, GPIOH_OSC_OUT)
 
 /*===========================================================================*/
 /* Driver pre-compile time settings.                                         */
diff --git a/modules/NUCLEO-F401RE/module.c b/modules/NUCLEO-F401RE/module.c
index dd2f724..106240d 100644
--- a/modules/NUCLEO-F401RE/module.c
+++ b/modules/NUCLEO-F401RE/module.c
@@ -62,8 +62,7 @@ SerialConfig moduleHalProgIfConfig = {
  * @brief   LED output signal GPIO.
  */
 static apalGpio_t _gpioLed = {
-  /* port */ GPIOA,
-  /* pad  */ GPIOA_LED_GREEN,
+  /* line */ LINE_LED_GREEN,
 };
 ROMCONST apalControlGpio_t moduleGpioLed = {
   /* GPIO */ &_gpioLed,
@@ -78,8 +77,7 @@ ROMCONST apalControlGpio_t moduleGpioLed = {
  * @brief   User button input signal GPIO.
  */
 static apalGpio_t _gpioUserButton = {
-  /* port */ GPIOC,
-  /* pad  */ GPIOC_BUTTON,
+  /* line */ LINE_BUTTON,
 };
 ROMCONST apalControlGpio_t moduleGpioUserButton = {
   /* GPIO */ &_gpioUserButton,
diff --git a/modules/NUCLEO-F401RE/module.h b/modules/NUCLEO-F401RE/module.h
index 23edbfc..e84cbac 100644
--- a/modules/NUCLEO-F401RE/module.h
+++ b/modules/NUCLEO-F401RE/module.h
@@ -91,7 +91,7 @@ extern ROMCONST apalControlGpio_t moduleGpioUserButton;
 /**
  * @brief   Event flag to be set on a USER_BUTTON interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_USERBUTTON       AOS_IOEVENT_FLAG(GPIOC_BUTTON)
+#define MODULE_OS_IOEVENTFLAGS_USERBUTTON       AOS_IOEVENT_FLAG(PAL_PAD(LINE_BUTTON))
 
 #if (AMIROOS_CFG_SHELL_ENABLE == true) || (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
 /**
@@ -106,8 +106,8 @@ extern ROMCONST char* moduleShellPrompt;
  */
 #define MODULE_INIT_INTERRUPTS() {                                            \
   /* user button */                                                           \
-  palSetPadCallback(moduleGpioUserButton.gpio->port, moduleGpioUserButton.gpio->pad, _intCallback, &moduleGpioUserButton.gpio->pad);  \
-  palEnablePadEvent(moduleGpioUserButton.gpio->port, moduleGpioUserButton.gpio->pad, APAL2CH_EDGE(moduleGpioUserButton.meta.edge));   \
+  palSetLineCallback(moduleGpioUserButton.gpio->line, aosSysGetStdIntCallback(), &moduleGpioUserButton.gpio->line); \
+  palEnableLineEvent(moduleGpioUserButton.gpio->line, APAL2CH_EDGE(moduleGpioUserButton.meta.edge));                \
 }
 
 /**
diff --git a/modules/NUCLEO-L476RG/alldconf.h b/modules/NUCLEO-L476RG/alldconf.h
index a644f5c..333b9d3 100644
--- a/modules/NUCLEO-L476RG/alldconf.h
+++ b/modules/NUCLEO-L476RG/alldconf.h
@@ -33,7 +33,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  */
 #define _AMIRO_LLD_CFG_
 #define AMIRO_LLD_CFG_VERSION_MAJOR             1
-#define AMIRO_LLD_CFG_VERSION_MINOR             0
+#define AMIRO_LLD_CFG_VERSION_MINOR             1
 
 /**
  * @brief   Width of the apalTime_t data type.
diff --git a/modules/NUCLEO-L476RG/board.h b/modules/NUCLEO-L476RG/board.h
index fab728d..5b08883 100644
--- a/modules/NUCLEO-L476RG/board.h
+++ b/modules/NUCLEO-L476RG/board.h
@@ -63,15 +63,15 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * IO pins assignments.
  */
 #define GPIOA_ARD_A0                0U
-#define GPIOA_ACD12_IN5             0U
+#define GPIOA_ADC12_IN5             0U
 #define GPIOA_ARD_A1                1U
-#define GPIOA_ACD12_IN6             1U
+#define GPIOA_ADC12_IN6             1U
 #define GPIOA_ARD_D1                2U
 #define GPIOA_USART2_TX             2U
 #define GPIOA_ARD_D0                3U
 #define GPIOA_USART2_RX             3U
 #define GPIOA_ARD_A2                4U
-#define GPIOA_ACD12_IN9             4U
+#define GPIOA_ADC12_IN9             4U
 #define GPIOA_ARD_D13               5U
 #define GPIOA_LED_GREEN             5U
 #define GPIOA_ARD_D12               6U
@@ -86,7 +86,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 #define GPIOA_PIN15                 15U
 
 #define GPIOB_ARD_A3                0U
-#define GPIOB_ACD12_IN15            0U
+#define GPIOB_ADC12_IN15            0U
 #define GPIOB_PIN1                  1U
 #define GPIOB_PIN2                  2U
 #define GPIOB_ARD_D3                3U
@@ -105,9 +105,9 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 #define GPIOB_PIN15                 15U
 
 #define GPIOC_ARD_A5                0U
-#define GPIOC_ACD123_IN1            0U
+#define GPIOC_ADC123_IN1            0U
 #define GPIOC_ARD_A4                1U
-#define GPIOC_ACD123_IN2            1U
+#define GPIOC_ADC123_IN2            1U
 #define GPIOC_PIN2                  2U
 #define GPIOC_PIN3                  3U
 #define GPIOC_PIN4                  4U
@@ -211,45 +211,47 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 /*
  * IO lines assignments.
  */
-#define LINE_ARD_A0                 PAL_LINE(GPIOA, 0U)
-#define LINE_ACD12_IN5              PAL_LINE(GPIOA, 0U)
-#define LINE_ARD_A1                 PAL_LINE(GPIOA, 1U)
-#define LINE_ACD12_IN6              PAL_LINE(GPIOA, 1U)
-#define LINE_ARD_D1                 PAL_LINE(GPIOA, 2U)
-#define LINE_USART2_TX              PAL_LINE(GPIOA, 2U)
-#define LINE_ARD_D0                 PAL_LINE(GPIOA, 3U)
-#define LINE_USART2_RX              PAL_LINE(GPIOA, 3U)
-#define LINE_ARD_A2                 PAL_LINE(GPIOA, 4U)
-#define LINE_ACD12_IN9              PAL_LINE(GPIOA, 4U)
-#define LINE_ARD_D13                PAL_LINE(GPIOA, 5U)
-#define LINE_LED_GREEN              PAL_LINE(GPIOA, 5U)
-#define LINE_ARD_D12                PAL_LINE(GPIOA, 6U)
-#define LINE_ARD_D11                PAL_LINE(GPIOA, 7U)
-#define LINE_ARD_D7                 PAL_LINE(GPIOA, 8U)
-#define LINE_ARD_D8                 PAL_LINE(GPIOA, 9U)
-#define LINE_ARD_D2                 PAL_LINE(GPIOA, 10U)
-#define LINE_SWDIO                  PAL_LINE(GPIOA, 13U)
-#define LINE_SWCLK                  PAL_LINE(GPIOA, 14U)
-#define LINE_ARD_A3                 PAL_LINE(GPIOB, 0U)
-#define LINE_ACD12_IN15             PAL_LINE(GPIOB, 0U)
-#define LINE_ARD_D3                 PAL_LINE(GPIOB, 3U)
-#define LINE_SWO                    PAL_LINE(GPIOB, 3U)
-#define LINE_ARD_D5                 PAL_LINE(GPIOB, 4U)
-#define LINE_ARD_D4                 PAL_LINE(GPIOB, 5U)
-#define LINE_ARD_D10                PAL_LINE(GPIOB, 6U)
-#define LINE_ARD_D15                PAL_LINE(GPIOB, 8U)
-#define LINE_ARD_D14                PAL_LINE(GPIOB, 9U)
-#define LINE_ARD_D6                 PAL_LINE(GPIOB, 10U)
-#define LINE_ARD_A5                 PAL_LINE(GPIOC, 0U)
-#define LINE_ACD123_IN1             PAL_LINE(GPIOC, 0U)
-#define LINE_ARD_A4                 PAL_LINE(GPIOC, 1U)
-#define LINE_ACD123_IN2             PAL_LINE(GPIOC, 1U)
-#define LINE_ARD_D9                 PAL_LINE(GPIOC, 7U)
-#define LINE_BUTTON                 PAL_LINE(GPIOC, 13U)
-#define LINE_OSC32_IN               PAL_LINE(GPIOC, 14U)
-#define LINE_OSC32_OUT              PAL_LINE(GPIOC, 15U)
-#define LINE_OSC_IN                 PAL_LINE(GPIOH, 0U)
-#define LINE_OSC_OUT                PAL_LINE(GPIOH, 1U)
+#define LINE_ARD_A0                 PAL_LINE(GPIOA, GPIOA_ARD_A0)
+#define LINE_ADC12_IN5              PAL_LINE(GPIOA, GPIOA_ADC12_IN5)
+#define LINE_ARD_A1                 PAL_LINE(GPIOA, GPIOA_ARD_A1)
+#define LINE_ADC12_IN6              PAL_LINE(GPIOA, GPIOA_ADC12_IN6)
+#define LINE_ARD_D1                 PAL_LINE(GPIOA, GPIOA_ARD_D1)
+#define LINE_USART2_TX              PAL_LINE(GPIOA, GPIOA_USART2_TX)
+#define LINE_ARD_D0                 PAL_LINE(GPIOA, GPIOA_ARD_D0)
+#define LINE_USART2_RX              PAL_LINE(GPIOA, GPIOA_USART2_RX)
+#define LINE_ARD_A2                 PAL_LINE(GPIOA, GPIOA_ARD_A2)
+#define LINE_ADC12_IN9              PAL_LINE(GPIOA, GPIOA_ADC12_IN9)
+#define LINE_ARD_D13                PAL_LINE(GPIOA, GPIOA_ARD_D13)
+#define LINE_LED_GREEN              PAL_LINE(GPIOA, GPIOA_LED_GREEN)
+#define LINE_ARD_D12                PAL_LINE(GPIOA, GPIOA_ARD_D12)
+#define LINE_ARD_D11                PAL_LINE(GPIOA, GPIOA_ARD_D11)
+#define LINE_ARD_D7                 PAL_LINE(GPIOA, GPIOA_ARD_D7)
+#define LINE_ARD_D8                 PAL_LINE(GPIOA, GPIOA_ARD_D8)
+#define LINE_ARD_D2                 PAL_LINE(GPIOA, GPIOA_ARD_D2)
+#define LINE_SWDIO                  PAL_LINE(GPIOA, GPIOA_SWDIO)
+#define LINE_SWCLK                  PAL_LINE(GPIOA, GPIOA_SWCLK)
+
+#define LINE_ARD_A3                 PAL_LINE(GPIOB, GPIOB_ARD_A3)
+#define LINE_ADC12_IN15             PAL_LINE(GPIOB, GPIOB_ADC12_IN15)
+#define LINE_ARD_D3                 PAL_LINE(GPIOB, GPIOB_ARD_D3)
+#define LINE_SWO                    PAL_LINE(GPIOB, GPIOB_SWO)
+#define LINE_ARD_D5                 PAL_LINE(GPIOB, GPIOB_ARD_D5)
+#define LINE_ARD_D4                 PAL_LINE(GPIOB, GPIOB_ARD_D4)
+#define LINE_ARD_D10                PAL_LINE(GPIOB, GPIOB_ARD_D10)
+#define LINE_ARD_D15                PAL_LINE(GPIOB, GPIOB_ARD_D15)
+#define LINE_ARD_D14                PAL_LINE(GPIOB, GPIOB_ARD_D14)
+#define LINE_ARD_D6                 PAL_LINE(GPIOB, GPIOB_ARD_D6)
+
+#define LINE_ARD_A5                 PAL_LINE(GPIOC, GPIOC_ARD_A5)
+#define LINE_ADC123_IN1             PAL_LINE(GPIOC, GPIOC_ADC123_IN1)
+#define LINE_ARD_A4                 PAL_LINE(GPIOC, GPIOC_ARD_A4)
+#define LINE_ADC123_IN2             PAL_LINE(GPIOC, GPIOC_ADC123_IN2)
+#define LINE_ARD_D9                 PAL_LINE(GPIOC, GPIOC_ARD_D9)
+#define LINE_BUTTON                 PAL_LINE(GPIOC, GPIOC_BUTTON)
+#define LINE_OSC32_IN               PAL_LINE(GPIOC, GPIOC_OSC32_IN)
+#define LINE_OSC32_OUT              PAL_LINE(GPIOC, GPIOC_OSC32_OUT)
+#define LINE_OSC_IN                 PAL_LINE(GPIOH, GPIOH_OSC_IN)
+#define LINE_OSC_OUT                PAL_LINE(GPIOH, GPIOH_OSC_OUT)
 
 /*===========================================================================*/
 /* Driver pre-compile time settings.                                         */
diff --git a/modules/NUCLEO-L476RG/module.c b/modules/NUCLEO-L476RG/module.c
index 611a0e7..ab805f1 100644
--- a/modules/NUCLEO-L476RG/module.c
+++ b/modules/NUCLEO-L476RG/module.c
@@ -72,8 +72,7 @@ I2CConfig moduleHalI2c3Config = {
  * @brief   LED output signal GPIO.
  */
 static apalGpio_t _gpioLed = {
-  /* port */ GPIOA,
-  /* pad  */ GPIOA_LED_GREEN,
+  /* line */ LINE_LED_GREEN,
 };
 ROMCONST apalControlGpio_t moduleGpioLed = {
   /* GPIO */ &_gpioLed,
@@ -88,8 +87,7 @@ ROMCONST apalControlGpio_t moduleGpioLed = {
  * @brief   User button input signal GPIO.
  */
 static apalGpio_t _gpioUserButton = {
-  /* port */ GPIOC,
-  /* pad  */ GPIOC_BUTTON,
+  /* line */ LINE_BUTTON,
 };
 ROMCONST apalControlGpio_t moduleGpioUserButton = {
   /* GPIO */ &_gpioUserButton,
diff --git a/modules/NUCLEO-L476RG/module.h b/modules/NUCLEO-L476RG/module.h
index 3591958..c38d503 100644
--- a/modules/NUCLEO-L476RG/module.h
+++ b/modules/NUCLEO-L476RG/module.h
@@ -106,7 +106,7 @@ extern ROMCONST apalControlGpio_t moduleGpioUserButton;
 /**
  * @brief   Event flag to be set on a USER_BUTTON interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_USERBUTTON       AOS_IOEVENT_FLAG(GPIOC_BUTTON)
+#define MODULE_OS_IOEVENTFLAGS_USERBUTTON       AOS_IOEVENT_FLAG(PAL_PAD(LINE_BUTTON))
 
 #if (AMIROOS_CFG_SHELL_ENABLE == true) || (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
 /**
@@ -121,8 +121,8 @@ extern ROMCONST char* moduleShellPrompt;
  */
 #define MODULE_INIT_INTERRUPTS() {                                            \
   /* user button */                                                           \
-  palSetPadCallback(moduleGpioUserButton.gpio->port, moduleGpioUserButton.gpio->pad, _intCallback, &moduleGpioUserButton.gpio->pad);  \
-  palEnablePadEvent(moduleGpioUserButton.gpio->port, moduleGpioUserButton.gpio->pad, APAL2CH_EDGE(moduleGpioUserButton.meta.edge));   \
+  palSetLineCallback(moduleGpioUserButton.gpio->line, aosSysGetStdIntCallback(), &moduleGpioUserButton.gpio->line); \
+  palEnableLineEvent(moduleGpioUserButton.gpio->line, APAL2CH_EDGE(moduleGpioUserButton.meta.edge));                \
 }
 
 /**
@@ -170,8 +170,8 @@ extern ROMCONST char* moduleShellPrompt;
     moduleHalI2c3Config.timingr |= ((((moduleHalI2c3Config.timingr & I2C_TIMINGR_SDADEL_Msk) >> I2C_TIMINGR_SDADEL_Pos) * 2) + 1) << I2C_TIMINGR_SCLDEL_Pos;  \
     /* now we can start the I2C driver */                                     \
     chSysLock();                                                              \
-    palSetPadMode(GPIOC, GPIOC_ARD_A4, PAL_MODE_ALTERNATE(4));                \
-    palSetPadMode(GPIOC, GPIOC_ARD_A5, PAL_MODE_ALTERNATE(4));                \
+    palSetLineMode(LINE_ARD_A4, PAL_MODE_ALTERNATE(4));                \
+    palSetLineMode(LINE_ARD_A5, PAL_MODE_ALTERNATE(4));                \
     chSysUnlock();                                                            \
     i2cStart(&MODULE_HAL_I2C3, &moduleHalI2c3Config);                         \
   }
diff --git a/modules/PowerManagement_1-1/alldconf.h b/modules/PowerManagement_1-1/alldconf.h
index 9a45185..a40490a 100644
--- a/modules/PowerManagement_1-1/alldconf.h
+++ b/modules/PowerManagement_1-1/alldconf.h
@@ -33,7 +33,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  */
 #define _AMIRO_LLD_CFG_
 #define AMIRO_LLD_CFG_VERSION_MAJOR             1
-#define AMIRO_LLD_CFG_VERSION_MINOR             0
+#define AMIRO_LLD_CFG_VERSION_MINOR             1
 
 /**
  * @brief   Width of the apalTime_t data type.
diff --git a/modules/PowerManagement_1-1/module.c b/modules/PowerManagement_1-1/module.c
index df06e06..4b38320 100644
--- a/modules/PowerManagement_1-1/module.c
+++ b/modules/PowerManagement_1-1/module.c
@@ -124,8 +124,7 @@ SerialConfig moduleHalProgIfConfig = {
  * @brief   SYS_REG_EN output signal GPIO.
  */
 static apalGpio_t _gpioSysRegEn = {
-  /* port */ GPIOA,
-  /* pad  */ GPIOA_SYS_REG_EN,
+  /* line */ LINE_SYS_REG_EN,
 };
 ROMCONST apalControlGpio_t moduleGpioSysRegEn = {
   /* GPIO */ &_gpioSysRegEn,
@@ -140,8 +139,7 @@ ROMCONST apalControlGpio_t moduleGpioSysRegEn = {
  * @brief   IR_INT1 input signal GPIO.
  */
 static apalGpio_t _gpioIrInt1 = {
-  /* port */ GPIOB,
-  /* pad  */ GPIOB_IR_INT1_N,
+  /* line */ LINE_IR_INT1_N,
 };
 ROMCONST apalControlGpio_t moduleGpioIrInt1 = {
   /* GPIO */ &_gpioIrInt1,
@@ -167,8 +165,7 @@ ROMCONST apalControlGpio_t moduleGpioIrInt1 = {
  * @brief   POWER_EN output signal GPIO.
  */
 static apalGpio_t _gpioPowerEn = {
-  /* port */ GPIOB,
-  /* pad  */ GPIOB_POWER_EN,
+  /* line */ LINE_POWER_EN,
 };
 ROMCONST apalControlGpio_t moduleGpioPowerEn = {
   /* GPIO */ &_gpioPowerEn,
@@ -183,8 +180,7 @@ ROMCONST apalControlGpio_t moduleGpioPowerEn = {
  * @brief   SYS_UART_DN bidirectional signal GPIO.
  */
 static apalGpio_t _gpioSysUartDn = {
-  /* port */ GPIOB,
-  /* pad  */ GPIOB_SYS_UART_DN,
+  /* line */ LINE_SYS_UART_DN,
 };
 ROMCONST apalControlGpio_t moduleGpioSysUartDn = {
   /* GPIO */ &_gpioSysUartDn,
@@ -199,8 +195,7 @@ ROMCONST apalControlGpio_t moduleGpioSysUartDn = {
  * @brief   CHARGE_STAT2A input signal GPIO.
  */
 static apalGpio_t _gpioChargeStat2A = {
-  /* port */ GPIOB,
-  /* pad  */ GPIOB_CHARGE_STAT2A,
+  /* line */ LINE_CHARGE_STAT2A,
 };
 ROMCONST apalControlGpio_t moduleGpioChargeStat2A = {
   /* GPIO */ &_gpioChargeStat2A,
@@ -215,8 +210,7 @@ ROMCONST apalControlGpio_t moduleGpioChargeStat2A = {
  * @brief   GAUGE_BATLOW2 input signal GPIO.
  */
 static apalGpio_t _gpioGaugeBatLow2 = {
-  /* port */ GPIOB,
-  /* pad  */ GPIOB_GAUGE_BATLOW2,
+  /* line */ LINE_GAUGE_BATLOW2,
 };
 ROMCONST apalControlGpio_t moduleGpioGaugeBatLow2 = {
   /* GPIO */ &_gpioGaugeBatLow2,
@@ -231,8 +225,7 @@ ROMCONST apalControlGpio_t moduleGpioGaugeBatLow2 = {
  * @brief   GAUGE_BATGD2 input signal GPIO.
  */
 static apalGpio_t _gpioGaugeBatGd2 = {
-  /* port */ GPIOB,
-  /* pad  */ GPIOB_GAUGE_BATGD2_N,
+  /* line */ LINE_GAUGE_BATGD2_N,
 };
 ROMCONST apalControlGpio_t moduleGpioGaugeBatGd2 = {
   /* GPIO */ &_gpioGaugeBatGd2,
@@ -247,8 +240,7 @@ ROMCONST apalControlGpio_t moduleGpioGaugeBatGd2 = {
  * @brief   LED output signal GPIO.
  */
 static apalGpio_t _gpioLed = {
-  /* port */ GPIOB,
-  /* pad  */ GPIOB_LED,
+  /* line */ LINE_LED,
 };
 ROMCONST apalControlGpio_t moduleGpioLed = {
   /* GPIO */ &_gpioLed,
@@ -263,8 +255,7 @@ ROMCONST apalControlGpio_t moduleGpioLed = {
  * @brief   SYS_UART_UP bidirectional signal GPIO.
  */
 static apalGpio_t _gpioSysUartUp = {
-  /* port */ GPIOB,
-  /* pad  */ GPIOB_SYS_UART_UP,
+  /* line */ LINE_SYS_UART_UP,
 };
 ROMCONST apalControlGpio_t moduleGpioSysUartUp = {
   /* GPIO */ &_gpioSysUartUp,
@@ -279,8 +270,7 @@ ROMCONST apalControlGpio_t moduleGpioSysUartUp = {
  * @brief   CHARGE_STAT1A input signal GPIO.
  */
 static apalGpio_t _gpioChargeStat1A = {
-  /* port */ GPIOC,
-  /* pad  */ GPIOC_CHARGE_STAT1A,
+  /* line */ LINE_CHARGE_STAT1A,
 };
 ROMCONST apalControlGpio_t moduleGpioChargeStat1A = {
   /* GPIO */ &_gpioChargeStat1A,
@@ -295,8 +285,7 @@ ROMCONST apalControlGpio_t moduleGpioChargeStat1A = {
  * @brief   GAUGE_BATLOW1 input signal GPIO.
  */
 static apalGpio_t _gpioGaugeBatLow1 = {
-  /* port */ GPIOC,
-  /* pad  */ GPIOC_GAUGE_BATLOW1,
+  /* line */ LINE_GAUGE_BATLOW1,
 };
 ROMCONST apalControlGpio_t moduleGpioGaugeBatLow1 = {
   /* GPIO */ &_gpioGaugeBatLow1,
@@ -311,8 +300,7 @@ ROMCONST apalControlGpio_t moduleGpioGaugeBatLow1 = {
  * @brief   GAUGE_BATGD1 input signal GPIO.
  */
 static apalGpio_t _gpioGaugeBatGd1 = {
-  /* port */ GPIOC,
-  /* pad  */ GPIOC_GAUGE_BATGD1_N,
+  /* line */ LINE_GAUGE_BATGD1_N,
 };
 ROMCONST apalControlGpio_t moduleGpioGaugeBatGd1 = {
   /* GPIO */ &_gpioGaugeBatGd1,
@@ -327,8 +315,7 @@ ROMCONST apalControlGpio_t moduleGpioGaugeBatGd1 = {
  * @brief   CHARG_EN1 output signal GPIO.
  */
 static apalGpio_t _gpioChargeEn1 = {
-  /* port */ GPIOC,
-  /* pad  */ GPIOC_CHARGE_EN1_N,
+  /* line */ LINE_CHARGE_EN1_N,
 };
 ROMCONST apalControlGpio_t moduleGpioChargeEn1 = {
   /* GPIO */ &_gpioChargeEn1,
@@ -343,8 +330,7 @@ ROMCONST apalControlGpio_t moduleGpioChargeEn1 = {
  * @brief   IR_INT2 input signal GPIO.
  */
 static apalGpio_t _gpioIrInt2 = {
-  /* port */ GPIOC,
-  /* pad  */ GPIOC_IR_INT2_N,
+  /* line */ LINE_IR_INT2_N,
 };
 ROMCONST apalControlGpio_t moduleGpioIrInt2 = {
   /* GPIO */ &_gpioIrInt2,
@@ -370,8 +356,7 @@ ROMCONST apalControlGpio_t moduleGpioIrInt2 = {
  * @brief   TOUCH_INT input signal GPIO.
  */
 static apalGpio_t _gpioTouchInt = {
-  /* port */ GPIOC,
-  /* pad  */ GPIOC_TOUCH_INT_N,
+  /* line */ LINE_TOUCH_INT_N,
 };
 ROMCONST apalControlGpio_t moduleGpioTouchInt = {
   /* GPIO */ &_gpioTouchInt,
@@ -397,8 +382,7 @@ ROMCONST apalControlGpio_t moduleGpioTouchInt = {
  * @brief   SYS_DONE input signal GPIO.
  */
 static apalGpio_t _gpioSysDone = {
-  /* port */ GPIOC,
-  /* pad  */ GPIOC_SYS_DONE,
+  /* line */ LINE_SYS_DONE,
 };
 ROMCONST apalControlGpio_t moduleGpioSysDone = {
   /* GPIO */ &_gpioSysDone,
@@ -413,8 +397,7 @@ ROMCONST apalControlGpio_t moduleGpioSysDone = {
  * @brief   SYS_PROG output signal GPIO.
  */
 static apalGpio_t _gpioSysProg = {
-  /* port */ GPIOC,
-  /* pad  */ GPIOC_SYS_PROG_N,
+  /* line */ LINE_SYS_PROG_N,
 };
 ROMCONST apalControlGpio_t moduleGpioSysProg = {
   /* GPIO */ &_gpioSysProg,
@@ -429,8 +412,7 @@ ROMCONST apalControlGpio_t moduleGpioSysProg = {
  * @brief   PATH_DC input signal GPIO.
  */
 static apalGpio_t _gpioPathDc = {
-  /* port */ GPIOC,
-  /* pad  */ GPIOC_PATH_DC,
+  /* line */ LINE_PATH_DC,
 };
 ROMCONST apalControlGpio_t moduleGpioPathDc = {
   /* GPIO */ &_gpioPathDc,
@@ -445,8 +427,7 @@ ROMCONST apalControlGpio_t moduleGpioPathDc = {
  * @brief   SYS_SPI_DIR bidirectional signal GPIO.
  */
 static apalGpio_t _gpioSysSpiDir = {
-  /* port */ GPIOC,
-  /* pad  */ GPIOC_SYS_SPI_DIR,
+  /* line */ LINE_SYS_SPI_DIR,
 };
 ROMCONST apalControlGpio_t moduleGpioSysSpiDir = {
   /* GPIO */ &_gpioSysSpiDir,
@@ -461,8 +442,7 @@ ROMCONST apalControlGpio_t moduleGpioSysSpiDir = {
  * @brief   SYS_SYNC bidirectional signal GPIO.
  */
 static apalGpio_t _gpioSysSync = {
-  /* port */ GPIOC,
-  /* pad  */ GPIOC_SYS_INT_N,
+  /* line */ LINE_SYS_INT_N,
 };
 ROMCONST apalControlGpio_t moduleGpioSysSync = {
   /* GPIO */ &_gpioSysSync,
@@ -477,8 +457,7 @@ ROMCONST apalControlGpio_t moduleGpioSysSync = {
  * @brief   SYS_PD bidirectional signal GPIO.
  */
 static apalGpio_t _gpioSysPd = {
-  /* port */ GPIOC,
-  /* pad  */ GPIOC_SYS_PD_N,
+  /* line */ LINE_SYS_PD_N,
 };
 ROMCONST apalControlGpio_t moduleGpioSysPd = {
   /* GPIO */ &_gpioSysPd,
@@ -493,8 +472,7 @@ ROMCONST apalControlGpio_t moduleGpioSysPd = {
  * @brief   SYS_WARMRST bidirectional signal GPIO.
  */
 static apalGpio_t _gpioSysWarmrst = {
-  /* port */ GPIOC,
-  /* pad  */ GPIOC_SYS_WARMRST_N,
+  /* line */ LINE_SYS_WARMRST_N,
 };
 ROMCONST apalControlGpio_t moduleGpioSysWarmrst = {
   /* GPIO */ &_gpioSysWarmrst,
@@ -509,8 +487,7 @@ ROMCONST apalControlGpio_t moduleGpioSysWarmrst = {
  * @brief   BT_RST output signal GPIO.
  */
 static apalGpio_t _gpioBtRst = {
-  /* port */ GPIOC,
-  /* pad  */ GPIOC_BT_RST,
+  /* line */ LINE_BT_RST,
 };
 ROMCONST apalControlGpio_t moduleGpioBtRst = {
   /* GPIO */ &_gpioBtRst,
@@ -525,8 +502,7 @@ ROMCONST apalControlGpio_t moduleGpioBtRst = {
  * @brief   CHARGE_EN2 output signal GPIO.
  */
 static apalGpio_t _gpioChargeEn2 = {
-  /* port */ GPIOD,
-  /* pad  */ GPIOD_CHARGE_EN2_N,
+  /* line */ LINE_CHARGE_EN2_N,
 };
 ROMCONST apalControlGpio_t moduleGpioChargeEn2 = {
   /* GPIO */ &_gpioChargeEn2,
